Bug 1166897 (mono-nat)

Summary: Review Request: mono-nat - Mono library for automatic port forwarding (new github project name: Mono.NAT)
Product: [Fedora] Fedora Reporter: Raphael Groner <projects.rg>
Component: Package ReviewAssignee: Nobody's working on this, feel free to take it <nobody>
Status: CLOSED NOTABUG QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: besser82, claudiorodrigo, extras-qa, package-review
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2016-11-05 23:05:53 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1089278, 1089426, 1220138, 1221559    
Bug Blocks:    

Description Raphael Groner 2014-11-21 22:02:23 UTC
Spec URL: https://raphgro.fedorapeople.org/review/mono/mono-nat/mono-nat.spec
SRPM URL: https://raphgro.fedorapeople.org/review/mono/mono-nat/mono-nat-1.1.0-3.fc20.src.rpm
Description: Mono library for automatic port forwarding
Fedora Account System Username: raphgro

Cause of mono, rpmlint shows wired false errors:
mono-nat.x86_64: E: no-binary
mono-nat.x86_64: W: only-non-binary-in-usr-lib
mono-nat-devel.x86_64: W: only-non-binary-in-usr-lib
mono-nat.src:2: E: hardcoded-library-path in %{_prefix}/lib/%{name}

This package is already in SCM but retired. I would like to bring it alive again.

Comment 1 Raphael Groner 2014-11-21 22:04:36 UTC
koji rawhide: https://koji.fedoraproject.org/koji/taskinfo?taskID=8204347

Comment 2 Björn 'besser82' Esser 2014-12-14 10:46:03 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Package do not use a name that already exist
  Note: A package already exist with this name, please check
  https://admin.fedoraproject.org/pkgdb/acls/name/mono-nat
  See:
  https://fedoraproject.org/wiki/Packaging/NamingGuidelines#Conflicting_Package_Names

---> Package exists in pkgdb, but is retiered.  This is a revive-review.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[-]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "MIT/X11 (BSD like)", "Unknown or generated". 5 files have unknown
     license. Detailed output of licensecheck in
     /home/besser82/shared/fedora/review/1166897-mono-nat/licensecheck.txt

---> According to licensecheck the license is fine.

[-]: License file installed when any subpackage combination is installed.
[-]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).

---> Execption for /usr/lib/ with Mono.

[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.

---> -devel-pkg as explained below.

[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[!]: Useful -debuginfo package or justification otherwise.

---> Empty debuginfo

[!]: Package is not known to require an ExcludeArch tag.

---> There are arches known which are not working with Mono…
     ---> BuildArch: %{mono_arches}

[!]: Package complies to the Packaging Guidelines

---> Issues are present.

[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.

---> Parallel-makejob fails.  Bug is commented in spec-file.

[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.

---> Cannot find any evidence on upstream's bug-tracker…

[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mono-nat-
     devel

---> Fix the Requires of the -devel-pkg as shown above, please.

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: mono-nat-1.1.0-3.fc22.x86_64.rpm
          mono-nat-devel-1.1.0-3.fc22.x86_64.rpm
          mono-nat-1.1.0-3.fc22.src.rpm
mono-nat.x86_64: W: spelling-error %description -l en_US uPnP -> upon
mono-nat.x86_64: W: spelling-error %description -l en_US pmp -> ppm, pm, pp
mono-nat.x86_64: E: no-binary
mono-nat.x86_64: W: only-non-binary-in-usr-lib
mono-nat.x86_64: W: no-documentation
mono-nat-devel.x86_64: W: only-non-binary-in-usr-lib
mono-nat-devel.x86_64: W: no-documentation
mono-nat.src: W: spelling-error %description -l en_US uPnP -> upon
mono-nat.src: W: spelling-error %description -l en_US pmp -> ppm, pm, pp
mono-nat.src:2: E: hardcoded-library-path in %{_prefix}/lib/%{name}
3 packages and 0 specfiles checked; 2 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
]0;<mock-chroot><mock-chroot>[root@x220 /]# rpmlint mono-nat-devel mono-nat
mono-nat-devel.x86_64: W: only-non-binary-in-usr-lib
mono-nat-devel.x86_64: W: no-documentation
mono-nat.x86_64: W: spelling-error %description -l en_US uPnP -> upon
mono-nat.x86_64: W: spelling-error %description -l en_US pmp -> ppm, pm, pp
mono-nat.x86_64: E: no-binary
mono-nat.x86_64: W: only-non-binary-in-usr-lib
mono-nat.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 1 errors, 6 warnings.
]0;<mock-chroot><mock-chroot>[root@x220 /]# echo 'rpmlint-done:'



Requires
--------
mono-nat-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    mono-nat
    pkgconfig

mono-nat (rpmlib, GLIBC filtered):
    mono(System)
    mono(System.Xml)
    mono(mscorlib)



Provides
--------
mono-nat-devel:
    mono-nat-devel
    mono-nat-devel(x86-64)
    pkgconfig(mono.nat)

mono-nat:
    mono(Mono.Nat)
    mono-nat
    mono-nat(x86-64)



Source checksums
----------------
http://projects.qnetp.net/attachments/download/76/mono-nat-1.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 34095f6524f9e6bebe0b696d76fbfcaba84cfe3ac04f811ba9d37fe14ba0bca1
  CHECKSUM(SHA256) upstream package : 34095f6524f9e6bebe0b696d76fbfcaba84cfe3ac04f811ba9d37fe14ba0bca1


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1166897
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


===== Solution =====

**NOT** approved, fix them issues and I'll have another run.

Comment 3 Dan Horák 2014-12-14 10:53:33 UTC
Please use ExclusiveArch: %{mono_arches} as Mono is not available on all platforms Fedora supports.

Comment 4 Raphael Groner 2014-12-14 16:48:03 UTC
Hi Björn,

thanks for the review.

What should be done about the parallel compilation issue? My suggestion is to use just xbuild directlyinstead of make.

As it turns out, the project moved to github. You can find there a valid license.

Comment 6 Björn 'besser82' Esser 2014-12-15 08:04:34 UTC
Currently package FTBFS…

INFO: Processing bugzilla bug: 1166897
INFO: Getting .spec and .srpm Urls from : 1166897
INFO:   --> SRPM url: https://raphgro.fedorapeople.org/review/mono/mono-nat/mono-nat-1.1.0-4.fc20.src.rpm
INFO:   --> Spec url: https://raphgro.fedorapeople.org/review/mono/mono-nat/mono-nat.spec
INFO: Using review directory: /home/besser82/shared/fedora/review/1166897-mono-nat
INFO: Downloading .spec and .srpm files
INFO: Downloading (Source2): https://raw.githubusercontent.com/mono/Mono.Nat/master/LICENSE#/mono-nat_LICENSE
WARNING: Cannot download url: https://raw.githubusercontent.com/mono/Mono.Nat/master/LICENSE#/mono-nat_LICENSE
INFO: No upstream for (Source2): LICENSE
INFO: Downloading (Source3): https://raw.githubusercontent.com/Mailaender/Mono.Nat/fb17acfe121f5a6d621bc44a2c59d1822c347f36/README.md#/mono-nat_README.md
WARNING: Cannot download url: https://raw.githubusercontent.com/Mailaender/Mono.Nat/fb17acfe121f5a6d621bc44a2c59d1822c347f36/README.md#/mono-nat_README.md
INFO: No upstream for (Source3): README.md
INFO: Downloading (Source0): https://github.com/mono/Mono.Nat/archive/Mono.Nat-1.1.0.tar.gz#/mono-nat-1.1.0.tar.gz
INFO: Downloading (Source1): https://raw.githubusercontent.com/mono/Mono.Nat/master/AUTHORS#/mono-nat_AUTHORS
WARNING: Cannot download url: https://raw.githubusercontent.com/mono/Mono.Nat/master/AUTHORS#/mono-nat_AUTHORS
INFO: No upstream for (Source1): AUTHORS
INFO: Running checks and generating report
INFO: Results and/or logs in: /home/besser82/shared/fedora/review/1166897-mono-nat/results
INFO: Build completed
INFO: Installing built package(s)
INFO: Active plugins: Generic, Shell-api
ERROR: 'Source2 file /home/besser82/shared/fedora/review/1166897-mono-nat/srpm-unpacked/LICENSE is missing in src.rpm. Conditional source inclusion?' (logs in /home/besser82/.cache/fedora-review.log)

If you want to have the files located on github, use the *complete* github-tarball instead…

Comment 7 Raphael Groner 2014-12-16 15:03:03 UTC
(In reply to Björn "besser82" Esser from comment #6)
> Currently package FTBFS…
> …
> If you want to have the files located on github, use the *complete*
> github-tarball instead…

As it turns out, the github tarball luckily includes LICENSE and AUTHORS. Unfortunately, this tarball does not provide any Makefile nor Makefile.in files, but Makefile.am only. I tried to tweak that somehow with autoreconf or automake, but without any success so far.

Please help to use automake properly. Otherwise, I would suggest to leave mono-nat as dead as it is ("to not wake up any bad zombie").

For reference, I'll upload the spec file without any claim to fix FTBFS.

https://raphgro.fedorapeople.org/review/mono/mono-nat/mono-nat.spec


Executing(%build): /bin/sh -e /var/tmp/rpm-tmp.JMcPjo
+ umask 022
+ cd /home/build/rpmbuild/BUILD
+ cd Mono.Nat-Mono.Nat-1.1.0
+ pushd src
~/rpmbuild/BUILD/Mono.Nat-Mono.Nat-1.1.0/src ~/rpmbuild/BUILD/Mono.Nat-Mono.Nat-1.1.0
+ autoreconf -i
configure.ac:5: installing './install-sh'
configure.ac:5: installing './missing'
Makefile.include:65: error: 'pkglibdir' is not a legitimate directory for 'SCRIPTS'
Mono.Nat/Makefile.am:96:   'Makefile.include' included from here
autoreconf: automake failed with exit status: 1
error: Bad exit status from /var/tmp/rpm-tmp.JMcPjo (%build)

Comment 8 Raphael Groner 2015-01-10 08:09:38 UTC
https://github.com/OpenRA/OpenRA/issues/7140

Comment 11 Raphael Groner 2015-01-26 16:15:07 UTC
ping?

Comment 12 Raphael Groner 2015-01-28 14:35:25 UTC
No reply since over two weeks, removing assigned reviewer due to I guess it is no interest any more.

Comment 13 Raphael Groner 2015-10-09 22:16:40 UTC
Spec URL: https://raphgro.fedorapeople.org/review/openra/mono-nat.spec
SRPM URL: https://raphgro.fedorapeople.org/review/openra/mono-nat-1.1.0-8.20150427git025b570.src.rpm

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11390769

* Wed Oct 07 2015 Raphael Groner <> - 1.1.0-8.20150427git025b570
- switch back to nterry fork
- rebuild with mono4
- use gacutil and sign binary
- clean useless commands

Comment 15 Claudio Rodrigo Pereyra DIaz 2015-11-06 14:23:37 UTC
I try review but %check fail in mock enviroment with 

"/var/tmp/rpm-tmp.mN8wMc: line 36: killall: command not found"

Please, not use killall or add "buildrequired: psmisc"

Comment 16 Raphael Groner 2015-11-07 09:50:33 UTC
Hi Claudio,
thanks for your interest. The test is there to ensure the binary is callable but it's running forever while we don't cancel the process. Now I use the timeout command instead of killall.


Spec URL: https://raphgro.fedorapeople.org/review/openra/mono-nat.spec
SRPM URL: https://raphgro.fedorapeople.org/review/openra/mono-nat-1.1.0-9.20150427git025b570.fc23.src.rpm

Comment 17 Raphael Groner 2015-11-07 10:15:31 UTC
Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11738642

Comment 18 Raphael Groner 2016-01-15 13:25:04 UTC
OpenRA moved to Open.NAT and obsoletes Mono.NAT, upstream is dead anyways. I doubt there's any sense to continue with this review?

Comment 19 Claudio Rodrigo Pereyra DIaz 2016-01-25 14:10:58 UTC
(In reply to Raphael Groner from comment #18)
> OpenRA moved to Open.NAT and obsoletes Mono.NAT, upstream is dead anyways. I
> doubt there's any sense to continue with this review?

I see that Mono.NAT is still alive. Few minor changes but alive. Also is under mono umbrella on github
I thing that will be good have Mono.NAT and Open.NAT into Fedora. Like other fork projects.

Open.Nat have a different focus in some features. See http://www.codeproject.com/Articles/807861/Open-NAT-A-NAT-Traversal-library-for-NET-and-Mono#Open.NAT%20and%20Mono.Nat

If you want open a new review for Open.Nat I will check it to.

Comment 20 Raphael Groner 2016-03-02 10:53:21 UTC
There was some activity in the mono master branch for dotnet 4.5.
commit/2889dda3dcf7ab9e70d02ca7c746f156e39934a2

Should we step from nterry fork to the original mono GitHub?